/*******************************************************************************
* File Name: .h
* Version 2.50
*
* Description:
*  This private header file contains internal definitions for the SPIM
*  component. Do not use these definitions directly in your application.
*
* Note:
*
********************************************************************************
* Copyright 2012-2015, Cypress Semiconductor Corporation. All rights reserved.
* You may use this file only in accordance with the license, terms, conditions,
* disclaimers, and limitations in the end user license agreement accompanying
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_SPIM_PVT_SSD1331_master_H)
#define CY_SPIM_PVT_SSD1331_master_H

#include "SSD1331_master.h"


/**********************************
*   Functions with external linkage
**********************************/


/**********************************
*   Variables with external linkage
**********************************/

extern volatile uint8 SSD1331_master_swStatusTx;
extern volatile uint8 SSD1331_master_swStatusRx;

#if(SSD1331_master_TX_SOFTWARE_BUF_ENABLED)
    extern volatile uint8 SSD1331_master_txBuffer[SSD1331_master_TX_BUFFER_SIZE];
    extern volatile uint8 SSD1331_master_txBufferRead;
    extern volatile uint8 SSD1331_master_txBufferWrite;
    extern volatile uint8 SSD1331_master_txBufferFull;
#endif /* (SSD1331_master_TX_SOFTWARE_BUF_ENABLED) */

#if(SSD1331_master_RX_SOFTWARE_BUF_ENABLED)
    extern volatile uint8 SSD1331_master_rxBuffer[SSD1331_master_RX_BUFFER_SIZE];
    extern volatile uint8 SSD1331_master_rxBufferRead;
    extern volatile uint8 SSD1331_master_rxBufferWrite;
    extern volatile uint8 SSD1331_master_rxBufferFull;
#endif /* (SSD1331_master_RX_SOFTWARE_BUF_ENABLED) */

#endif /* CY_SPIM_PVT_SSD1331_master_H */


/* [] END OF FILE */
