/*******************************************************************************
* File Name: nRST.h  
* Version 2.20
*
* Description:
*  This file contains Pin function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_nRST_H) /* Pins nRST_H */
#define CY_PINS_nRST_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "nRST_aliases.h"

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 nRST__PORT == 15 && ((nRST__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

/**
* \addtogroup group_general
* @{
*/
void    nRST_Write(uint8 value);
void    nRST_SetDriveMode(uint8 mode);
uint8   nRST_ReadDataReg(void);
uint8   nRST_Read(void);
void    nRST_SetInterruptMode(uint16 position, uint16 mode);
uint8   nRST_ClearInterrupt(void);
/** @} general */

/***************************************
*           API Constants        
***************************************/
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup driveMode Drive mode constants
     * \brief Constants to be passed as "mode" parameter in the nRST_SetDriveMode() function.
     *  @{
     */
        #define nRST_DM_ALG_HIZ         PIN_DM_ALG_HIZ
        #define nRST_DM_DIG_HIZ         PIN_DM_DIG_HIZ
        #define nRST_DM_RES_UP          PIN_DM_RES_UP
        #define nRST_DM_RES_DWN         PIN_DM_RES_DWN
        #define nRST_DM_OD_LO           PIN_DM_OD_LO
        #define nRST_DM_OD_HI           PIN_DM_OD_HI
        #define nRST_DM_STRONG          PIN_DM_STRONG
        #define nRST_DM_RES_UPDWN       PIN_DM_RES_UPDWN
    /** @} driveMode */
/** @} group_constants */
    
/* Digital Port Constants */
#define nRST_MASK               nRST__MASK
#define nRST_SHIFT              nRST__SHIFT
#define nRST_WIDTH              1u

/* Interrupt constants */
#if defined(nRST__INTSTAT)
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup intrMode Interrupt constants
     * \brief Constants to be passed as "mode" parameter in nRST_SetInterruptMode() function.
     *  @{
     */
        #define nRST_INTR_NONE      (uint16)(0x0000u)
        #define nRST_INTR_RISING    (uint16)(0x0001u)
        #define nRST_INTR_FALLING   (uint16)(0x0002u)
        #define nRST_INTR_BOTH      (uint16)(0x0003u) 
    /** @} intrMode */
/** @} group_constants */

    #define nRST_INTR_MASK      (0x01u) 
#endif /* (nRST__INTSTAT) */


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define nRST_PS                     (* (reg8 *) nRST__PS)
/* Data Register */
#define nRST_DR                     (* (reg8 *) nRST__DR)
/* Port Number */
#define nRST_PRT_NUM                (* (reg8 *) nRST__PRT) 
/* Connect to Analog Globals */                                                  
#define nRST_AG                     (* (reg8 *) nRST__AG)                       
/* Analog MUX bux enable */
#define nRST_AMUX                   (* (reg8 *) nRST__AMUX) 
/* Bidirectional Enable */                                                        
#define nRST_BIE                    (* (reg8 *) nRST__BIE)
/* Bit-mask for Aliased Register Access */
#define nRST_BIT_MASK               (* (reg8 *) nRST__BIT_MASK)
/* Bypass Enable */
#define nRST_BYP                    (* (reg8 *) nRST__BYP)
/* Port wide control signals */                                                   
#define nRST_CTL                    (* (reg8 *) nRST__CTL)
/* Drive Modes */
#define nRST_DM0                    (* (reg8 *) nRST__DM0) 
#define nRST_DM1                    (* (reg8 *) nRST__DM1)
#define nRST_DM2                    (* (reg8 *) nRST__DM2) 
/* Input Buffer Disable Override */
#define nRST_INP_DIS                (* (reg8 *) nRST__INP_DIS)
/* LCD Common or Segment Drive */
#define nRST_LCD_COM_SEG            (* (reg8 *) nRST__LCD_COM_SEG)
/* Enable Segment LCD */
#define nRST_LCD_EN                 (* (reg8 *) nRST__LCD_EN)
/* Slew Rate Control */
#define nRST_SLW                    (* (reg8 *) nRST__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define nRST_PRTDSI__CAPS_SEL       (* (reg8 *) nRST__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define nRST_PRTDSI__DBL_SYNC_IN    (* (reg8 *) nRST__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define nRST_PRTDSI__OE_SEL0        (* (reg8 *) nRST__PRTDSI__OE_SEL0) 
#define nRST_PRTDSI__OE_SEL1        (* (reg8 *) nRST__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define nRST_PRTDSI__OUT_SEL0       (* (reg8 *) nRST__PRTDSI__OUT_SEL0) 
#define nRST_PRTDSI__OUT_SEL1       (* (reg8 *) nRST__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define nRST_PRTDSI__SYNC_OUT       (* (reg8 *) nRST__PRTDSI__SYNC_OUT) 

/* SIO registers */
#if defined(nRST__SIO_CFG)
    #define nRST_SIO_HYST_EN        (* (reg8 *) nRST__SIO_HYST_EN)
    #define nRST_SIO_REG_HIFREQ     (* (reg8 *) nRST__SIO_REG_HIFREQ)
    #define nRST_SIO_CFG            (* (reg8 *) nRST__SIO_CFG)
    #define nRST_SIO_DIFF           (* (reg8 *) nRST__SIO_DIFF)
#endif /* (nRST__SIO_CFG) */

/* Interrupt Registers */
#if defined(nRST__INTSTAT)
    #define nRST_INTSTAT            (* (reg8 *) nRST__INTSTAT)
    #define nRST_SNAP               (* (reg8 *) nRST__SNAP)
    
	#define nRST_0_INTTYPE_REG 		(* (reg8 *) nRST__0__INTTYPE)
#endif /* (nRST__INTSTAT) */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_nRST_H */


/* [] END OF FILE */
