/* ========================================
 *
 * Copyright Oz-Fi audio®, 2020
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF Oz-Fi audio®.
 *
 * ========================================
*/

#ifndef _SSD1331_H_
#define _SSD1331_H_

/*************************
*       INCLUDES
**************************/    
#include "lvgl.h"
#include "project.h"

/*********************
 *      DEFINES
 *********************/
    
#define SET_COLUMN_ADDRESSES    0x15
#define SET_ROW_ADDRESSES       0x75
#define SET_A_CONTRAST          0x81
#define SET_B_CONTRAST          0x82
#define SET_C_CONTRAST          0x83
#define MASTERCURRENTCONTROL    0x87
#define PRECHARGE_A             0x8A
#define PRECHARGE_B             0x8B
#define PRECHARGE_C             0X8C
#define REMAP_COLORDEPTH        0xA0
#define SET_STARTLINE           0xA1
#define SET_OFFSET              0xA2
#define SET_NORMALDISPLAYMODE   0xA4
#define SET_DISPLAYON           0xA5
#define SET_DISPLAYOFF          0xA6
#define SET_INVERSEDISPLAY      0xA7
#define SET_MULTIPLEX           0xA8
#define DIM_MODE                0xAB
#define SET_MASTERCONFIG        0xAD
#define DISPLAYOFF              0xAE    
#define DISPLAYON               0xAF
#define POWER_MODE              0xB0
#define DISP_CLK_DIVID          0xB3
#define EN_LIN_GRAYSCALE_TAB    0xB9
#define SET_PRECHARGE_LVL       0xBB
#define SET_VCOM                0xBE
#define DEACTIVE_SCROLLING      0x2E

#define RGB(R,G,B)                  (((R>>3)<<11) | ((G>>2)<<5) | (B>>3))
enum Color{
    COLOR_BLACK     = RGB(  0,  0,  0), // black
    COLOR_GREY      = RGB(192,192,192), // grey
    COLOR_WHITE     = RGB(255,255,255), // white
    COLOR_RED       = RGB(255,  0,  0), // red
    COLOR_PINK      = RGB(255,192,203), // pink
    COLOR_YELLOW    = RGB(255,255,  0), // yellow
    COLOR_GOLDEN    = RGB(255,215,  0), // golden
    COLOR_BROWN     = RGB(128, 42, 42), // brown
    COLOR_BLUE      = RGB(  0,  0,255), // blue
    COLOR_CYAN      = RGB(  0,255,255), // cyan
    COLOR_GREEN     = RGB(  0,255,  0), // green
    COLOR_PURPLE    = RGB(160, 32,240), // purple
};
    
    
/*************************
*   FUNCTION PROTOTYPES
**************************/
void flush_cb( lv_disp_drv_t * disp_drv, const lv_area_t * area, lv_color_t * color_p );
void lv_disp_init();
#endif      //_SSD1331_H_

/*  []  END OF FILE */